import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.CsvFileSource;

import static org.junit.jupiter.api.Assertions.*;
import static org.junit.jupiter.api.Assumptions.assumingThat;

public class EmployeeTest {
    Employee employee = null;

    @BeforeEach
    void setup() {
        employee = new Employee();
    }

    @ParameterizedTest
    @CsvFileSource(resources = "/EmployeeTestData.csv")
    public void testGetFirstName(String firstName, String lastName, String dob, String addressLine1,
                                 String addressLine2, String city, String state, int postalCode) {
        this.employee = new Employee(firstName, lastName, dob, addressLine1,
                addressLine2, city, state, postalCode);
        assertAll(
                () -> assertNotNull(employee),
                () -> assertEquals(firstName, employee.getFirstName()),
                () -> assertEquals(lastName, employee.getLastName()),
                () -> assertEquals(dob, employee.getDob()),
                () -> assertEquals(addressLine1, employee.getAddress1()),
                () -> assertEquals(addressLine2, employee.getAddress2()),
                () -> assertEquals(city, employee.getCity()),
                () -> assertEquals(state, employee.getState()),
                () -> assertEquals(postalCode, employee.getPostalCode())
        );
    }

    @Test
    public void assumingThatEmployeeTest() {
        assumingThat(employee == null,
                () -> assertTrue(employee.getFirstName() != null, "assumingThatTest -  Failed"));

        assertFalse(employee.getFirstName() != null, "assumingThatTest -  Failed");
    }
}
